// svn4dw.cpp : Defines the entry point for the DLL application.
//

#include <mm_jsapi.h>
#include "stdafx.h"
#include "stdlib.h"
#include "SCSShell.h"
#include "logfile.h"
#include "svn4dw.h"
#include "libintl.h"
#include "db.h"

// subversion includes
//#include "svn_error.h"
//#include "svn_client.h"
//#include "svn_pools.h"

void APIENTRY xxxxxxx(){
	void*yyyyy=sprintf;
}


#include <windows.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		logFunctionCall ( "DllMain: DLL_PROCESS_ATTACH" );
		break;
	case DLL_THREAD_ATTACH:
		logFunctionCall ( "DllMain: DLL_THREAD_ATTACH"  );
		break;
	case DLL_THREAD_DETACH:
		logFunctionCall ( "DllMain: DLL_THREAD_DETACH"  );
		break;
	case DLL_PROCESS_DETACH:
		logFunctionCall ( "DllMain: DLL_PROCESS_DETACH" );
		break;
	}
    return TRUE;
}

const char * ROOT_FOLDER_NAME = "myroot";
// each folder has two items: folder/ y file.txt, ad infinitum
const char * SUBFOLDER_NAME  = "folder";
const char * FILE_NAME       = "file.txt";
svn4dwca sharedCA;



/*
void MM_Init() {
	logFunctionCall ( "MM_Init" );
	JS_DefineFunction("SCS_Connect", SCS_Connect, 1);
}
*/

/*
// This is an example of an exported variable
SVN4DW_API int nsvn4dw=0;

// This is an example of an exported function.
SVN4DW_API int fnsvn4dw(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see svn4dw.h for the class definition
Csvn4dw::Csvn4dw()
{ 
	return; 
}
*/



/* ==== UTILITY FUNCTIONS === */

void SCS__SetItemInfo(
	itemInfo &item, const char*name, bool isFolder, 
	int month, int day, int year, 
	int hour, int minutes, int seconds,
	char * type, int size)
{
	strncpy(item.name, name, sizeof(item.name));
	item.isFolder = isFolder;
	item.month = month;
	item.day = day;
	item.year = year;
	item.hour = hour;
	item.minutes = minutes;
	item.seconds = seconds;
	if (type) {
		strncpy(item.type, type, sizeof(item.type));
	} else {
		item.type[0] = '\0';
	}
	item.size = size;
}

/* ==== EXPORTED FUNCTIONS === */



/**
 * ======== == ======== ==========
 *  SECTION I: REQUIRED FUNCTIONS
 * ======== == ======== ==========
 *
 * The Source Control Integration API has required and optional functions. 
 * The functions listed in this section are required.
 */


/**
 * Description
 * - This function asks the DLL to return its name and description, which appear 
 *   in the Edit Sites dialog box. The name appears in the Server Access pop-up 
 *   menu (for example, sourcesafe, webdav, perforce) and the description below 
 *   the pop-up menu.
 * Arguments
 * - The name argument is the name of the source control system. The name 
 *   appears in the combo box for selecting a source control system on the Source 
 *   Control tab in the Edit Sites dialog box. The name can be a maximum of 32 characters. 
 * - The version argument is a string that indicates the version of the DLL. 
 *   The version appears on the Source Control tab in the Edit Sites dialog box. 
 *   The version can be a maximum of 32 characters. 
 * - The description argument is a string that indicates the description of the 
 *   source control system. The description appears on the Source Control tab in 
 *   the Edit Sites dialog box. The description can be a maximum of 256 characters. 
 * - The dwAppVersion argument is a string that indicates the version of Dreamweaver 
 *   that is calling the DLL. The DLL can use this string to determine the version 
 *   and language of Dreamweaver.
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_GetAgentInfo(char name[32], char version[32], char description[256], const char *dwAppVersion)
{
	logFunctionCall ( "SCS_GetAgentInfo" );
	strncpy(name, "Subversion", 32);
	strncpy(version, "0.1", 32);
	strncpy(description, "Subversion for Dreamwever Extension ", 256);
	strncat(description, dwAppVersion, 256);
	return true;
};


/**
 * Description
 * - This function connects the user to the source control system.
 *   If the DLL does not have log-in information, the DLL must display 
 *   a dialog box to prompt the user for the information and must store 
 *   the data for later use.
 * Arguments
 * - The connectionData argument is a handle to the data that the agent 
 *   wants Dreamweaver to pass to it when calling other API functions. 
 * - The siteName argument is a string that points to the name of the 
 *   site. The site name can be a maximum of 64 characters. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_Connect(void **connectionData, char siteName[64])
{
	logFunctionCall ( "SCS_Connect" );
	*connectionData = &sharedCA;
	return true;
}


/**
 * Description
 * - This function disconnects the user from the source control system.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that 
 *   passed into Dreamweaver during the Connect() call. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_Disconnect(void *connectionData)
{
	logFunctionCall ( "SCS_Disconnect" );
	return true;
}


/**
 * Description
 * - This function determines the state of the connection.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that 
 *   passed into Dreamweaver during the Connect() call. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_IsConnected(void *connectionData)
{
	logFunctionCall ( "SCS_IsConnected" );
	return true;
}


/**
 * Description
 * - This function returns the length of the name of the root folder.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that 
 *   passed into Dreamweaver during the Connect() call. 
 * Returns
 * - An integer that indicates the length of the name of the root folder. If 
 *   the function returns < 0, Dreamweaver considers it an error and tries 
 *   to retrieve the error message from the DLL, if supported. 
 */
SCSSHELL_EXPORT int SCS_GetRootFolderLength(
	void *connectionData)
{
	logFunctionCall ( "SCS_GetRootFolderLength" );
	return (int) strlen(ROOT_FOLDER_NAME);
}


/**
 * Description
 * - This function returns the name of the root folder.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed into 
 *   Dreamweaver during the Connect() call. 
 * - The remoteFolderPath is a buffer where the full remote path of the root folder is stored. 
 * - The folderLen argument is an integer that indicates the length of remotePath.
 *   This is the value that GetRootFolderLength returns. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_GetRootFolder(
	void *connectionData, char remoteFolderPath[], const int folderLen)
{
	logFunctionCall ( "SCS_GetRootFolder" );
	strncpy(remoteFolderPath, ROOT_FOLDER_NAME, folderLen);
	return true;
}

/**
 * Description
 * - This function returns the number of items in the passed-in folder
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed 
 *   into Dreamweaver during the Connect() call. 
 * - The remotePath argument is the full path and name of the remote folder 
 *   that the DLL checks for the number of items. 
 * Returns
 * - An integer that indicates the number of items in the current folder. If 
 *   the function returns < 0, Dreamweaver considers it an error and tries to retrieve the error message from the DLL, if supported. 
 */
SCSSHELL_EXPORT int SCS_GetFolderListLength(
	void *connectionData, const char *remotePath)
{
	logFunctionCall ( "SCS_GetFolderListLength" );
	return 2;
}

/**
 * Description
 *   This function returns a list of files and folders in the passed-in folder,
 *   including pertinent information such as modified date, size, and whether 
 *   the item is a folder or file.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed 
 *   into Dreamweaver during the Connect() call. 
 * - The remotePath argument is the path of the remote folder that the DLL 
 *   checks for the number of items. 
 * - The itemList argument is a preallocated list of itemInfo structures:
 *
 *	name      char[256] Name of file or folder
 *	isFolder  bool      true if folder; false if file
 *	month     int       Month component of modification date 1-12
 *	day       int       Day component of modification date 1-31
 *	year      int       Year component of modification date 1900+
 *	hour      int       Hour component of modification date 0-23
 *	minutes   int       Minute component of modification date 0-59
 *	seconds   int       Second component of modification date 0-59
 *	type      char[256] Type of file (if not set by DLL, Dreamweaver uses file 
 *                      extensions to determine type, as it does now)
 *	size      int       In bytes
 *
 * - The numItems argument is the number of items that are allocated for the 
 *   itemList (returned from GetFolderListLength). 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */

SCSSHELL_EXPORT bool SCS_GetFolderList(
	void *connectionData, const char remoteFolderPath[],
	scItemInfo itemList[], const int numItems)
{
	logFunctionCall ( "SCS_GetFolderList" );

	if (connectionData == NULL){
		logError ( "SCS_GetFolderList (NULL)" );
		return false;
	}

	svn4dwca * ca = ((svn4dwca*)connectionData);


	apr_pool_t *pool = ca->pool;
	svn_client_ctx_t *ctx = ca->ctx; // recuperar de *connectionData
	apr_hash_t *dirents; // para pasar a svn_client_ls

	svn_opt_revision_t *revision = NULL; // latest ?
	
	svn_boolean_t recurse = FALSE; // set to false


	apr_pool_t *subpool = svn_pool_create (pool); 
	
	CHECK_SVN_RET (svn_client_ls (&dirents, remoteFolderPath, revision,
									recurse, ctx, pool));
			
	{ // loop
	SCS__SetItemInfo(itemList[0], SUBFOLDER_NAME, true,  1,1,1,1,1,1,NULL,0);
	}

	svn_pool_clear (subpool);





	// end of svn_cl__ls



	return true;
}

/**
 * Description
 *   This function gets a list of files or folders and stores them locally.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed 
 *   into Dreamweaver during the Connect() call. 
 * - The remotePathList argument is a list of the remote files or folders to 
 *   retrieve, which is specified as complete paths and names. 
 * - The localPathList argument is a mirrored list of local filenames or folder 
 *   paths. 
 * - The numItems argument is the number of items in each list. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_Get(
	void *connectionData, const filePath remotePathList[], 
	const filePath localPathList[], const int numItems)
{
	logFunctionCall ( "SCS_Get" );
	// TODO
	return true;
}

#include "SCSShell.h"
/**
 * Description
 *   This function puts a list of local files or folders into the source control 
 *   system.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed into 
 *   Dreamweaver during the Connect() call. 
 * - The localPathList argument is the list of local filenames or folder paths to 
 *   put into the source control system. 
 * - The remotePathList argument is a mirrored list of remote filenames or folder 
 *   paths. 
 * - The numItems argument is the number of items in each list. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_Put(
	void *connectionData, const filePath localPathList[], 
	const filePath remotePathList[], const int numItems)
{
	logFunctionCall ( "SCS_Put" );
	// TODO
	return true;
}

/**
 * Description
 *   This function creates a new folder.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed into 
 *   Dreamweaver during the Connect() call. 
 * - The remotePath argument is the full path of the remote folder that the DLL 
 *   creates. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_NewFolder(
	void *connectionData, const char *remotePath)
{
	logFunctionCall ( "SCS_NewFolder" );
	// TODO
	return true;
}

/**
 * Description
 * This function deletes a list of files or folders from the source control system.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed into 
 *   Dreamweaver during the Connect() call. 
 * - The remotePathList argument is a list of remote filenames or folder paths to 
 *   delete. 
 * - The numItems argument is the number of items in remotePathList. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_Delete(
	void *connectionData, const filePath remotePathList[], const int numItems)
{
	logFunctionCall ( "SCS_Delete" );
	// TODO
	return true;
}

/**
 * Description
 * - This function renames or moves a file or folder, depending on the values that 
 *   are specified for oldRemotePath and newRemotePath. For example, if oldRemotePath 
 *   equals "$/folder1/file1" and newRemotePath equals "$/folder1/renamefile1", file1 
 *   is renamed renamefile1 and is located in folder1. 
 * - If oldRemotePath equals "$/folder1/file1" and newRemotePath equals 
 *   "$/folder1/subfolder1/file1", file1 is moved to the subfolder1 folder.
 * - To find out if an invocation of this function is a move or a rename, check the 
 *   parent paths of the two input values; if they are the same, the operation is a rename.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed into 
 *   Dreamweaver during the Connect() call. 
 * - The oldRemotePath argument is a remote file or folder path to rename. 
 * - The newRemotePath argument is the remote path of the new name for the file or folder. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
*/ 
SCSSHELL_EXPORT bool SCS_Rename(
	void *connectionData, const char *oldRemotePath, const char *newRemotePath)
{
	logFunctionCall ( "SCS_Rename" );
	// TODO
	return true;
}

/**
 * Description
 * - This function determines whether a file or folder exists on the server.
 * Arguments
 * - The connectionData argument is a pointer to the agents data that passed into 
 *   Dreamweaver during the Connect() call. 
 * - The remotePath argument is a remote file or folder path. 
 * Returns
 * - A Boolean value: true if successful; false otherwise.
 */
SCSSHELL_EXPORT bool SCS_ItemExists(
	void *connectionData, const char *remotePath)
{
	logFunctionCall ( "SCS_ItemExists" );
	// TODO
	return remotePath != NULL && (strcmp(FILE_NAME, remotePath) || strcmp(SUBFOLDER_NAME, remotePath));
}

